SystemOrganization addCategory: #'Universes-Editor'!
SystemOrganization addCategory: #'Universes-Browser'!
SystemOrganization addCategory: #'Universes-Policy'!
SystemOrganization addCategory: #'Universes-Model'!
SystemOrganization addCategory: #'Universes-Tests'!
SystemOrganization addCategory: #'Universes-Server'!
SystemOrganization addCategory: #'Universes-Client'!
SystemOrganization addCategory: #'Universes-Installers'!
SystemOrganization addCategory: #'Universes-Messages'!


Object subclass: #UAccount
	instanceVariableNames: 'username password email packageNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

Model subclass: #UAccountEditor
	instanceVariableNames: 'username password newPassword newPassword2 newEmail whenDone window fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

TestCase subclass: #UBrowserTestCase
	instanceVariableNames: 'universe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

Object subclass: #UConfiguration
	instanceVariableNames: 'installedPackages'
	classVariableNames: 'SystemConfiguration'
	poolDictionaries: ''
	category: 'Universes-Model'!

Object subclass: #UInstaller
	instanceVariableNames: ''
	classVariableNames: 'Installers'
	poolDictionaries: ''
	category: 'Universes-Installers'!

UInstaller subclass: #UIFileOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

UInstaller subclass: #UIMonticello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

UInstaller subclass: #UIMpeg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

UInstaller subclass: #UIProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

UInstaller subclass: #UISar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

Object subclass: #UMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMAddAccount
	instanceVariableNames: 'username password email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMAddPackage
	instanceVariableNames: 'username password package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMEditAccount
	instanceVariableNames: 'username password newPassword newEmail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMEditedAccount
	instanceVariableNames: 'username newPassword newEmail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMError
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMError subclass: #UMConnectionFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMMalformed
	instanceVariableNames: 'stringArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMPackageAdded
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMPackageList
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMPackageRemoved
	instanceVariableNames: 'packageName version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMRemovePackage
	instanceVariableNames: 'username password packageName packageVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

UMessage subclass: #UMRequestPackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

Object subclass: #UOneShotConnection
	instanceVariableNames: 'inputMessage outputQueue hasBeenRead hasBeenWritten'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

Object subclass: #UPackage
	instanceVariableNames: 'name version description depends url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

Model subclass: #UPackageEditor
	instanceVariableNames: 'package whenComplete fields window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

Object subclass: #UPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

UPolicy subclass: #UPStable
	instanceVariableNames: 'masterUser masterPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

UPolicy subclass: #UPWild
	instanceVariableNames: 'accounts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

UPolicy subclass: #UPermissivePolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

Object subclass: #UPolicyResponse
	instanceVariableNames: 'allowed reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

Flasher subclass: #UServerStepperMorph
	instanceVariableNames: 'server timeOfLastFlash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

Object subclass: #UUniverse
	instanceVariableNames: 'description'
	classVariableNames: 'SystemUniverse'
	poolDictionaries: ''
	category: 'Universes-Model'!

UUniverse subclass: #UCompoundUniverse
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

UUniverse subclass: #UStandardUniverse
	instanceVariableNames: 'serverName serverPort packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

Model subclass: #UUniverseBrowser
	instanceVariableNames: 'universe configuration serverConnections clients selectedPackageIndex packagesToInstall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Browser'!

Object subclass: #UUniverseClient
	instanceVariableNames: 'universe inMessages outMessages socket stringSocket lastConnectionStart useHTTP'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Client'!

Object subclass: #UUniverseEditor
	instanceVariableNames: 'universe client username password email usernameField passwordField packageEditors accountEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

Object subclass: #UUniverseServer
	instanceVariableNames: 'universe policy saveDirectory lastSaveTime connectionQueue oneShotRequests connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

Object subclass: #UUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

Magnitude subclass: #UVersion
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

TestCase subclass: #UVersionTestCase
	instanceVariableNames: 'typicalVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

UAccount class
	instanceVariableNames: ''!

UAccountEditor class
	instanceVariableNames: ''!

UBrowserTestCase class
	instanceVariableNames: ''!

UConfiguration class
	instanceVariableNames: ''!

UInstaller class
	instanceVariableNames: ''!

UIFileOut class
	instanceVariableNames: ''!

UIMonticello class
	instanceVariableNames: ''!

UIMpeg class
	instanceVariableNames: ''!

UIProject class
	instanceVariableNames: ''!

UISar class
	instanceVariableNames: ''!

UMessage class
	instanceVariableNames: ''!

UMAddAccount class
	instanceVariableNames: ''!

UMAddPackage class
	instanceVariableNames: ''!

UMEditAccount class
	instanceVariableNames: ''!

UMEditedAccount class
	instanceVariableNames: ''!

UMError class
	instanceVariableNames: ''!

UMConnectionFailed class
	instanceVariableNames: ''!

UMMalformed class
	instanceVariableNames: ''!

UMPackageAdded class
	instanceVariableNames: ''!

UMPackageList class
	instanceVariableNames: ''!

UMPackageRemoved class
	instanceVariableNames: ''!

UMRemovePackage class
	instanceVariableNames: ''!

UMRequestPackages class
	instanceVariableNames: ''!

UOneShotConnection class
	instanceVariableNames: ''!

UPackage class
	instanceVariableNames: ''!

UPackageEditor class
	instanceVariableNames: ''!

UPolicy class
	instanceVariableNames: ''!

UPStable class
	instanceVariableNames: ''!

UPWild class
	instanceVariableNames: ''!

UPermissivePolicy class
	instanceVariableNames: ''!

UPolicyResponse class
	instanceVariableNames: ''!

UServerStepperMorph class
	instanceVariableNames: ''!

UUniverse class
	instanceVariableNames: ''!

UCompoundUniverse class
	instanceVariableNames: ''!

UStandardUniverse class
	instanceVariableNames: ''!

UUniverseBrowser class
	instanceVariableNames: ''!

UUniverseClient class
	instanceVariableNames: ''!

UUniverseEditor class
	instanceVariableNames: ''!

UUniverseServer class
	instanceVariableNames: ''!

UUtilities class
	instanceVariableNames: ''!

UVersion class
	instanceVariableNames: ''!

UVersionTestCase class
	instanceVariableNames: ''!


!UAccount commentStamp: '<historical>' prior: 0!
An account as used in the standard UPolicy's.!

!UAccountEditor commentStamp: '<historical>' prior: 0!
A tool for editing an account!

!UCompoundUniverse commentStamp: 'ls 7/29/2004 18:48' prior: 0!
A universe that is the union of other universes.!

!UConfiguration commentStamp: '<historical>' prior: 0!
One configuration of packages.!

!UInstaller commentStamp: '<historical>' prior: 0!
A simply hierarchy for loading Squeak content in various formats.!

!UMAddAccount commentStamp: '<historical>' prior: 0!
A request to add a user account.
!

!UMConnectionFailed commentStamp: '<historical>' prior: 0!
An error in establishing a connection to a server.!

!UMEditAccount commentStamp: '<historical>' prior: 0!
A request to change the password or email of an account.
!

!UMEditedAccount commentStamp: '<historical>' prior: 0!
Notification that an account has been successfully edited.!

!UMError commentStamp: '<historical>' prior: 0!
An error message from the server to the client.!

!UMMalformed commentStamp: '<historical>' prior: 0!
a malformed packet!

!UMPackageAdded commentStamp: 'ls 7/28/2004 15:08' prior: 0!
A message declaring that a package has been added to the universe.
!

!UMPackageList commentStamp: '<historical>' prior: 0!
A message describing a list of packages that are in the server's universe.!

!UMPackageRemoved commentStamp: '<historical>' prior: 0!
A message claiming that a package has been removed.!

!UMRemovePackage commentStamp: '<historical>' prior: 0!
A request to remove a package from a universe.
!

!UMRequestPackages commentStamp: '<historical>' prior: 0!
A package requesting that a copy of all packages in the server's universe.!

!UMessage commentStamp: '<historical>' prior: 0!
A message that can be sent to or from a UServer.  All instances may be converted to an array of strings, and that array of strings may be parsed back with fromStringArray:.!

!UOneShotConnection commentStamp: '<historical>' prior: 0!
A fake StringSocket used to integrate a UUniverseServer with an HTTP server.

A OneShotConnection has exactly one input message and only accepts one output message.  It puts the supplied output message onto a SharedQueue and then disconnects itself.
!

!UPStable commentStamp: '<historical>' prior: 0!
A policy somewhat suitable for stable versions.  All updates must come through a single master userid and password.!

!UPWild commentStamp: '<historical>' prior: 0!
This is the wild-n-wooly policy.  Anyone may create a new account, and the first person to try to add or remove a package with a given name comes to exclusively own that package name.  Only the owner of a package name may make changes to packages with that name.!

!UPackage commentStamp: 'ls 7/27/2004 21:20' prior: 0!
One release of one package.!

!UPackageEditor commentStamp: '<historical>' prior: 0!
A simple GUI for editing a package and then doing something with it.
!

!UPermissivePolicy commentStamp: '<historical>' prior: 0!
A policy that allows anything.
!

!UPolicy commentStamp: '<historical>' prior: 0!
A policy for manipulations on a universe.  All of the methods return 'true' on success or on allowing the requested operation, or 'false' on an error or if the operation is not allowed.  By default everything is disallowed.

Note that since policy is completely implemented on the server, there is no requirement that a particular UUniverse has a policy describable with this class or a subclass.  A particular server can always modify UUniverseServer to implement an arbitrary policy.!

!UPolicyResponse commentStamp: '<historical>' prior: 0!
A response to a policy query.!

!UServerStepperMorph commentStamp: '<historical>' prior: 0!
A morph that simply steps a UniverseServer continuously.
!

!UStandardUniverse commentStamp: 'ls 7/28/2004 10:36' prior: 0!
A universe that looks to one single server for authoritative information.
!

!UUniverse commentStamp: 'ls 7/27/2004 21:24' prior: 0!
One universe of packages.
!

!UUniverseBrowser commentStamp: '<historical>' prior: 0!
A tool to support one-click installs and upgrades of packages within a universe.!

!UUniverseClient commentStamp: 'ls 7/30/2004 14:58' prior: 0!
A client for talking to a universe server.

The universe must be a UStandardUniverse.  The client will track update the universe automatically as messages come in.
!

!UUniverseEditor commentStamp: '<historical>' prior: 0!
A tool for editing a remote universe.
!

!UUniverseServer commentStamp: '<historical>' prior: 0!
A server holding the authoratative information about a universe.  Clients may make requests to view and update the universe.
!

!UUtilities commentStamp: 'ls 7/28/2004 10:35' prior: 0!
Universe miscellania that belong to no particular object.
!

!UVersion commentStamp: '<historical>' prior: 0!
A relatively simple hierarchical version number.!

!UVersion methodsFor: 'comparing' stamp: 'ls 7/27/2004 21:15'!
< aVersion
	| numToCompare |
	numToCompare := components size min: aVersion components size.
	(components first: numToCompare) with: (aVersion components first: numToCompare) do: [ :myComp :itsComp |
		(myComp uversionLessThan: itsComp) ifTrue: [
			^true ].
		(itsComp uversionLessThan: myComp) ifTrue: [
			^false ] ].
	
	^components size < aVersion components size! !

!UInstaller methodsFor: 'comparing' stamp: 'ls 7/29/2004 11:02'!
= anInstaller
	^self class = anInstaller class! !

!UPackage methodsFor: 'comparing' stamp: 'ls 7/28/2004 10:04'!
= anotherPackage
	self name = anotherPackage name ifFalse: [ ^false ].
	self version = anotherPackage version ifFalse: [ ^false ].
	self description = anotherPackage description ifFalse:[ ^false ].
	self depends = anotherPackage depends ifFalse: [ ^false ].
	self url toText = anotherPackage url toText ifFalse: [ ^false ].
	
	^true
! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/27/2004 17:31'!
= aVersion
	components size = aVersion components size ifFalse:[ ^false ].

	components with: aVersion components do: [ :myComp :itsComp |
		(myComp uversionEqual: itsComp) ifFalse: [
			^false ] ].
	
	^true! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 11:02'!
acceptConnection: stringSocket
	connections add: stringSocket! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 11:02'!
acceptConnectionOn: socket
	self acceptConnection: (StringSocket on: socket).
	! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:52'!
acceptFields
	fields do: [ :f | f accept ]! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:41'!
acceptFields
	fields do: [ :f | f accept ]! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:17'!
acceptFields
	{passwordField.usernameField} do: [ :f | f accept ]! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 18:00'!
accountUpdatedWithUsername: newUsername  password:  newPassword  email: newEmail
	self acceptFields.
	username _ newUsername.
	password _ newPassword.
	email _ newEmail.
	
	self changed: #username.
	self changed: #password.
	self changed: #email.
	
	self closeAccountEditor! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:19'!
addDependency: aString
	depends add: aString! !

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:07'!
addPackage: aPackage
	"make sure that we end up with no two packages with the same name and version"
	packages removeAllSuchThat: [ :p | p name = aPackage name and: [ p version = aPackage version ] ].
	
	"now add the new package"
	packages add: aPackage! !

!UAccount methodsFor: 'packages' stamp: 'ls 7/28/2004 18:03'!
addPackageName: name
	packageNames add: name! !

!UUniverse methodsFor: 'packages' stamp: 'ls 7/29/2004 19:09'!
addPackages: newPackages
	newPackages do: [ :p | self addPackage: p ]! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 17:59'!
addUser: user withPassword: password andEmail: email
	^UPolicyResponse denied! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/29/2004 16:49'!
addUser: username withPassword: password  andEmail: email
	| newAccount |
	(accounts anySatisfy: [ :acc | acc username = username]) ifTrue: [
		"already an account here"
		^UPolicyResponse denied: 'account already exists' ].
	
	(self class isReasonableUsername: username) ifFalse: [
		^UPolicyResponse denied: 'invalid account name' ].
	
	newAccount _ UAccount new.
	newAccount username: username.
	newAccount password: password.
	newAccount email: email.
	
	accounts add: newAccount.
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
addUser: user  withPassword: password  andEmail: email
	^UPolicyResponse allowed! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
addUser: user  withPassword: password  andEmail: email
	^UPolicyResponse denied! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:31'!
allPackagesNeededToInstall: initialPackage  orIfImpossible: errorBlock
	"find all packages needed to installed initialPackage; if it is impossible to accomplish, invoke errorBlock with the name of the missing package"
	| newPackages packagesToConsider |
	newPackages _ Set new.
	packagesToConsider _ OrderedCollection with: initialPackage.
	[ packagesToConsider isEmpty ] whileFalse: [
		| package |
		package _ packagesToConsider removeFirst.
		(newPackages includes: package) ifFalse: [
			newPackages add: package.
			package depends do: [ :depName |
				((configuration includesPackageNamed: depName) not and: [ packagesToInstall noneSatisfy: [ :p | p name = depName  ] ])
				ifTrue: [
					"the dependency is needed but is not installed or planned to be installed"
					(universe hasPackageNamed: depName) ifTrue: [
						"in principle, one could additionally consider trying a different package than the newest..."
						packagesToConsider add: (universe newestPackageNamed: depName) ]
					ifFalse: [
						^errorBlock value: depName ] ] ] ] ].
	
	^newPackages! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
allowed
	^allowed! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:47'!
allowed
	^self allowed: nil! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
allowed: anObject
	allowed _ anObject! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 10:34'!
allowed: reason
	^self allowed: true  reason: reason! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:46'!
allowed: aBoolean  reason: aReason
	^self basicNew
		allowed: aBoolean;
		reason: (aReason ifNil: ['no reason given']);
		yourself! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:34'!
anyPackageSelected
	^selectedPackageIndex > 0! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 9/4/2004 14:36'!
anyPackagesToInstall
	^packagesToInstall isEmpty not! !

!UMPackageAdded methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:01'!
applyToClient: aClient
	aClient packageAdded: package! !

!UMPackageList methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:01'!
applyToClient: aClient
	aClient newPackageList: packages! !

!UMPackageRemoved methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:02'!
applyToClient: aClient
	aClient removedPackageNamed: packageName  withVersion: version! !

!UMessage methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:00'!
applyToClient: aClient
	"apply this message to a UUniverseClient"
	! !

!UMEditedAccount methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 17:59'!
applyToEditor: editor
	editor accountUpdatedWithUsername: username  password:  newPassword  email: newEmail! !

!UMError methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 21:58'!
applyToEditor: editor
	"the inform: is deferred, because otherwise the editor can stop stepping!!"
	WorldState addDeferredUIMessage: [ editor inform: 'Error: ', description ]
! !

!UMPackageAdded methodsFor: '*universes-editor' stamp: 'ls 7/30/2004 15:38'!
applyToEditor: editor
	editor closeEditorForPackage: package.
! !

!UMessage methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 15:40'!
applyToEditor: editor
	! !

!UMError methodsFor: '*universes-installer' stamp: 'ls 7/28/2004 21:58'!
applyToInstaller: installer
	"the inform: is deferred, because otherwise the installer can stop stepping!!"
	WorldState addDeferredUIMessage: [ installer inform: 'Error from server: ', description ]! !

!UMPackageList methodsFor: '*universes-installer' stamp: 'ls 7/28/2004 13:57'!
applyToInstaller: installer
	installer newPackageList: packages! !

!UMessage methodsFor: '*universes-installer' stamp: 'ls 7/28/2004 11:53'!
applyToInstaller: anInstaller
	"by default, the installer ignores messages"
	! !

!UMAddAccount methodsFor: '*universes-server' stamp: 'ls 7/28/2004 21:46'!
applyToServer: server forConnection: connection
	server connection: connection requestedAccountWithUsername: username password: password email: email! !

!UMAddPackage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:03'!
applyToServer: server forConnection: connection
	server connection: connection requestedForUsername: username andPassword: password toAddPackage: package! !

!UMEditAccount methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:55'!
applyToServer: server forConnection: connection
	server connection: connection requestedAccountChangeForUsername: username password: password newPassword: newPassword newEmail: newEmail! !

!UMError methodsFor: '*universes-server' stamp: 'ls 7/28/2004 13:35'!
applyToServer: server forConnection: connection
	"if the client sends an error back, then the connection is really messed up"
	server destroyConnection: connection
	! !

!UMRemovePackage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:20'!
applyToServer: server forConnection: connection
	server connection: connection requestedForUsername: username andPassword: password toRemovePackageNamed: packageName withVersion: packageVersion! !

!UMRequestPackages methodsFor: '*universes-server' stamp: 'ls 7/28/2004 13:08'!
applyToServer: server forConnection: connection
	connection nextPut: (UMPackageList packages: server universe packages) asStringArray
! !

!UMessage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:25'!
applyToServer: server  forConnection: connection
self inspect.
	connection nextPut: (UMError description: 'message inappropriate for server') asStringArray! !

!UMAddAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 14:34'!
asStringArray
	^{'addaccount' . username . password . email}! !

!UMAddPackage methodsFor: 'converting' stamp: 'ls 7/28/2004 16:56'!
asStringArray
	^{'addpackage' . username . password },
	  package stringArrayEncoding! !

!UMEditAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 14:36'!
asStringArray
	^{'editaccount' . username . password . newPassword . newEmail}! !

!UMEditedAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 17:37'!
asStringArray
	^{'editedaccount' . username . newPassword . newEmail }! !

!UMError methodsFor: 'converting' stamp: 'ls 7/28/2004 13:36'!
asStringArray
	^{'error' . description }! !

!UMMalformed methodsFor: 'converting' stamp: 'ls 7/28/2004 11:31'!
asStringArray
	^self error: 'a malformed packet cannot be converted to a string array'! !

!UMPackageAdded methodsFor: 'converting' stamp: 'ls 7/28/2004 15:07'!
asStringArray
	^#('packageadded'), package stringArrayEncoding! !

!UMPackageList methodsFor: 'converting' stamp: 'ls 7/28/2004 15:04'!
asStringArray
	^Array streamContents: [ :str |
		str nextPut: 'packages'.
		str nextPut: packages size printString.
		packages do: [ :pack |
			str nextPutAll: pack stringArrayEncoding ]. ].! !

!UMPackageRemoved methodsFor: 'converting' stamp: 'ls 7/28/2004 14:57'!
asStringArray
	^{'packageremoved' . packageName . version printString }! !

!UMRemovePackage methodsFor: 'converting' stamp: 'ls 7/29/2004 15:46'!
asStringArray
	^{'removepackage' . username . password . packageName . packageVersion printString }
! !

!UMRequestPackages methodsFor: 'converting' stamp: 'ls 7/28/2004 11:59'!
asStringArray
	^#('requestpackages')! !

!UMessage methodsFor: 'converting' stamp: 'ls 7/28/2004 11:30'!
asStringArray
	^self subclassResponsibility! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 9/4/2004 14:16'!
canMarkSelectionForInstallation
	^self anyPackageSelected and: [ (packagesToInstall includes: self selectedPackage) not ]! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 17:59'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	"the changes must be made on the server, not over the standard protocol"
	^UPolicy denied! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/30/2004 15:46'!
changeUser: username withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	| account |
	account _ self findAccount: username withPassword: password.
	account ifNil: [ ^UPolicyResponse denied: 'username not present or password does not match' ].
	
	newPassword isEmpty ifFalse: [account password: newPassword ].
	newEmail isEmpty ifFalse: [account email: newEmail ].
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	^UPolicyResponse allowed! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	^UPolicyResponse denied! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 13:15'!
checkForNewConnections
	connectionQueue ifNil: [ ^self ].
	[ connections size < 10 ] whileTrue: [
		| newSocket |
		newSocket _ connectionQueue getConnectionOrNil.
		newSocket ifNil: [ ^self ].
		connections add: (StringSocket on: newSocket) ].
	! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/2/2004 16:54'!
checkForOneShotRequests
	[ oneShotRequests isEmpty ] whileFalse: [
		| reqAndQ requestMessage responseQueue |
		reqAndQ _ oneShotRequests next.
		requestMessage _ reqAndQ first.
		responseQueue _ reqAndQ second.
		
		self acceptConnection: (UOneShotConnection withInMessage: requestMessage andOutQueue: responseQueue) ].
	! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/28/2004 10:27'!
chooseUpgrades
	"select packages that appear to be upgrades of packages that are already installed"
	universe packageNames do: [ :name |
		(configuration includesPackageNamed: name) ifTrue: [
			| cpack mypack |
			cpack _ configuration packageNamed: name.
			mypack _ universe newestPackageNamed: name.
			mypack version > cpack version ifTrue: [
				self planToInstallPackageWithoutUIUpdate: mypack ] ] ].
	
	self changed: #packageDescriptions.! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:58'!
closeAccountEditor
	accountEditor ifNil: [ ^self ].
	accountEditor window delete.
	accountEditor _ nil.! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:12'!
closeEditorForPackage: package
	| matchingEditors |
	matchingEditors _ packageEditors select: [ :p | p package = package ].
	matchingEditors do: [ :editor |
		editor window delete.
		packageEditors remove: editor ].! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/3/2004 18:10'!
comancheServiceName
	^'universe server on ', universe serverPort printString! !

!UVersion methodsFor: 'attributes' stamp: 'ls 7/27/2004 17:33'!
components
	^components! !

!UCompoundUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:48'!
components: anObject
	components _ anObject! !

!UVersion methodsFor: 'initialization' stamp: 'ls 7/27/2004 17:27'!
components: aCollection
	components _ aCollection! !

!UCompoundUniverse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:47'!
composedOf: universes
	^self new
		components: universes;
		yourself! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:58'!
configuration: aConfiguration
	configuration _ aConfiguration! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:53'!
connection: connection requestedAccountChangeForUsername: username  password: password  newPassword: newPassword newEmail: newEmail
	| response |
	response _ policy changeUser: username withPassword: password toHavePassword: newPassword andNewEmail: newEmail.
	response allowed ifFalse: [
		^self
			sendError: 'changing account for ', username, ' failed (', response reason, ')'
			onConnection: connection].
		
	self sendMessage: (UMEditedAccount username: username newPassword: newPassword newEmail: newEmail) onConnection: connection! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:53'!
connection: connection requestedAccountWithUsername: username  password: password  email: email 
	| response |
	response _ policy addUser: username withPassword: password andEmail: email.
	response allowed ifFalse: [
		self
			sendError: 'adding account for ', username, ' failed (', response reason, ')'
			onConnection: connection].! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:54'!
connection: connection requestedForUsername: username  andPassword: password  toAddPackage: package
	| response |
	response _ policy package: package mayBeAddedBy: username withPassword: password.
	
	response allowed
		ifFalse: [
			^self 
				sendError: 'adding package ', package name, ' failed (', response reason, ')'
				onConnection: connection].
		
	universe addPackage: package.


	self sendMessage: (UMPackageAdded package: package) onConnection: connection.! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:54'!
connection: connection requestedForUsername: username  andPassword: password  toRemovePackageNamed: packageName withVersion: version
	| packagesToRemove response |
	response _ policy packageNamed: packageName withVersion: version mayBeRemovedBy: username withPassword: password.
	
	response allowed ifFalse: [
		^self 
			sendError: 'removing package ', packageName, ' failed (', response reason, ')' 
			onConnection: connection].
		
	packagesToRemove := universe packages select: [ :p | p name = packageName and: [ p version = version ] ].
	packagesToRemove do: [ :p |
		universe removePackage: p ].
	
	self sendMessage: (UMPackageRemoved packageName: packageName version: version) onConnection: connection.! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 21:44'!
createAccount
	self acceptFields.

	email _ FillInTheBlankMorph request: 'email?'.
	
	self sendMessage: (UMAddAccount username: username password: password email: email).
	! !

!UPackage class methodsFor: '*universes-messages' stamp: 'ls 7/28/2004 15:05'!
decodeFromStringStream: str
	| package numDepends |
	package _ self new.
	package name: str next.
	package version: (UVersion readFromString: str next).
	package description: str next.
	package url: (Url absoluteFromText: str next).
	numDepends _ Integer readFromString: str next. 
	numDepends timesRepeat: [
		package addDependency: str next ].
	^package! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/3/2004 18:04'!
decodeStringArray: aString
	| idx numStrings |
	idx _ 1.
	numStrings _ aString getInteger32: idx.
	idx _ idx + 4.
	numStrings < 0 ifTrue: [ ^self error: 'invalid string socket encoding' ].
	numStrings > 10000000 ifTrue: [ self error: 'refusing to decode humongous string socket' ].
	
	^(1 to: numStrings) collect: [ :ignored |
		| size str |
		size _ aString getInteger32: idx.
		idx _ idx + 4.
		str _ aString copyFrom: idx to: idx+size-1.
		idx _ idx + size.
		str ]
	! !

!UServerStepperMorph methodsFor: 'closing' stamp: 'ls 8/2/2004 17:05'!
delete
	super delete.
	server stopListening.
	server stopListeningOnHttp.! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:46'!
denied
	^self denied: nil! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 17:58'!
denied: reason
	^self allowed: false  reason: reason! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
depends
	^depends! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 15:39'!
depends: aCollection
	depends _ Set withAll: aCollection! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/29/2004 15:26'!
dependsString
	| first |
	first _ true.
	^String streamContents: [ :str |
		package depends do: [ :depName |
			first ifTrue:[ first _ false ] ifFalse: [ str nextPutAll: ', ' ].
			str nextPutAll: depName ] ]
	! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/29/2004 15:27'!
dependsString: aString
	| depNames |
	depNames _ aString asString findTokens: ','.
	depNames _ depNames collect: [ :d | d withBlanksTrimmed ].

	package depends: depNames.
	self changed: #dependsString! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
description
	^description! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:40'!
description
	^package description! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 16:18'!
description
	^description! !

!UMError methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 13:26'!
description: aString
	description := aString! !

!UMError class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 13:33'!
description: aString
	^self basicNew
		description: aString;
		yourself! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
description: aString
	description _ aString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:41'!
description: aString
	package description: aString asString.
	self changed: #description.
	^true! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 16:16'!
description: aString
	description _ aString! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:33'!
destroy
	hasBeenWritten _ true! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:47'!
destroyConnection: aConnection
	aConnection destroy.
	connections remove: aConnection ifAbsent: [].! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:10'!
disconnect
	"explicitly close the connection"
	socket ifNotNil: [ socket destroy.  socket _ nil ].
	stringSocket ifNotNil: [ stringSocket destroy.  stringSocket _ nil ].! !

!UUniverseBrowser methodsFor: 'server communication' stamp: 'ls 7/30/2004 15:09'!
disconnectFromServer
	clients keys do: [ :client |
		client disconnect ].
! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 9/4/2004 14:19'!
doInstall
	| orderedPackages |
	packagesToInstall isEmpty ifTrue: [
		^self inform: 'no packages selected to install' ].
		
	orderedPackages := UUniverseBrowser orderPackagesByDependency: packagesToInstall.
	orderedPackages do: [ :p | 
		Utilities informUser: 'installing ', p printString during: [
			configuration installPackage: p ] ].
	packagesToInstall _ Set new.
	self changed: #packageDescriptions.! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:58'!
editAccount
	| editor |
	self acceptFields.
	self closeAccountEditor.
	
	editor _ UAccountEditor
		username: username
		password: password
		email:  ''
		whenDone: [ :newPassword :newEmail |
			self sendMessage: (UMEditAccount username: username password: password newPassword: newPassword newEmail: newEmail) ].
		
	editor openInMorphic.
	
	accountEditor _ editor.! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
email: aString
	email _ aString! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/2/2004 16:18'!
encodeStringArray: stringArray
	| size outBuf outBufIndex |
	size _ self spaceToEncode: stringArray.
	
	outBuf _ String new: size.
	outBufIndex _ 1.

	outBuf putInteger32: stringArray size at: outBufIndex.
	outBufIndex _ outBufIndex + 4.
	stringArray do: [ :each |
		outBuf putInteger32: each size at: outBufIndex.
		outBufIndex _ outBufIndex + 4.
		outBuf 
			replaceFrom: outBufIndex 
			to: outBufIndex + each size - 1 
			with: each 
			startingAt: 1.
		outBufIndex _ outBufIndex + each size.
	].
	
	^outBuf! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/2/2004 16:55'!
eventuallyRespondTo: inputStringArray  on: outputQueue
	oneShotRequests nextPut:
		{
			inputStringArray.
			outputQueue
		}! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 7/29/2004 20:03'!
exampleCompoundUniverse
	"[UUniverse switchSystemToUniverse: UUniverse exampleCompoundUniverse]"
	^(UCompoundUniverse composedOf: {
		self wildnWoollyUniverse.
		self homeMoviesUniverse
	}) description: 'example compound universe'; yourself! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 18:14'!
findAccount: username withPassword: password
	| account |
	account _ accounts detect: [ :acc | acc username = username] ifNone: [
		"no such account"
		^nil ].
	
	account password = password ifFalse:[
		"wrong password"
		^nil ].
	
	^account! !

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 09:29'!
forSaveDirectory: aDirectory
	| universe |
	universe _ self forUniverse: UUniverse new.
	universe saveDirectory: aDirectory.
	universe loadFromCheckpoint.
	^universe! !

!UConfiguration class methodsFor: 'system' stamp: 'ls 7/27/2004 21:57'!
forSystem
	"return a configuration describing the currently running system"
	^SystemConfiguration ifNil: [ SystemConfiguration _ self new ].
	! !

!UUniverseClient class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 15:06'!
forUniverse: aStandardUniverse
	^self basicNew
		initialize: aStandardUniverse;
		yourself! !

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 10:23'!
forUniverse: aStandardUniverse
	^self basicNew
		initialize: aStandardUniverse;
		yourself! !

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 10:31'!
forUniverse: universe
	^self basicNew initializeForUniverse: universe.
	! !

!UVersion class methodsFor: 'instance creation' stamp: 'ls 7/27/2004 17:24'!
fromComponents: components
	^self basicNew components: components; yourself! !

!UMAddAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:34'!
fromStringArray: stringArray
	^self username: stringArray second password: stringArray third email: stringArray fourth! !

!UMAddPackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:07'!
fromStringArray: array
	^self username: array second password: array third package: (UPackage decodeFromStringStream: (ReadStream on: (array allButFirst: 3)))! !

!UMEditAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:38'!
fromStringArray: array
	^self username: array second password: array third newPassword: array fourth newEmail: array fifth! !

!UMEditedAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:38'!
fromStringArray: array
	^self username: array second newPassword: array third newEmail: array fourth! !

!UMError class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:02'!
fromStringArray: array
	^self description: array second! !

!UMMalformed class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 11:30'!
fromStringArray: array
	^self basicNew stringArray: array; yourself! !

!UMPackageAdded class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:07'!
fromStringArray: array
	| str |
	str _ ReadStream on: array.
	str next.
	^self package: (UPackage decodeFromStringStream: str)! !

!UMPackageList class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:05'!
fromStringArray: array
	| str packages numPackages |
	str _ ReadStream on: array.
	str next.  "skip the 'packages' designation".

	packages _ OrderedCollection new.

	numPackages _ Integer readFromString: str next.
	numPackages timesRepeat: [
		packages add: (UPackage decodeFromStringStream: str) ].
		
	^self packages: packages! !

!UMPackageRemoved class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:58'!
fromStringArray: array
	^self packageName: array second version: (UVersion readFromString: array third)! !

!UMRemovePackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:26'!
fromStringArray: array
	^self username: array second password: array third packageName: array fourth packageVersion: (UVersion readFromString: array fifth)! !

!UMRequestPackages class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 11:59'!
fromStringArray: array
	^self basicNew! !

!UMessage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:38'!
fromStringArray: array
	| class |
	class _ nil.
	array first = 'requestpackages' ifTrue: [ class _ UMRequestPackages ].
	array first = 'packages' ifTrue: [ class _ UMPackageList ].
	array first = 'error' ifTrue: [ class _ UMError ].
	array first = 'addaccount' ifTrue: [ class _ UMAddAccount ].
	array first = 'addpackage' ifTrue: [ class _ UMAddPackage ].
	array first = 'editaccount' ifTrue: [ class _ UMEditAccount ].
	array first = 'editedaccount' ifTrue: [ class _ UMEditedAccount ].
	array first = 'packageadded' ifTrue: [ class _ UMPackageAdded ].
	array first = 'packageremoved' ifTrue: [ class _ UMPackageRemoved ].
	array first = 'removepackage' ifTrue: [ class _ UMRemovePackage ].

	class ifNil: [
			^UMMalformed fromStringArray: array ].
	
	^[ class fromStringArray: array ] on: Error do: [ :ex | UMMalformed fromStringArray: array ]! !

!UIMonticello methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('mcz') includes: ending! !

!UIMpeg methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('mpg' 'mpeg') includes: ending! !

!UIProject methodsFor: 'testing' stamp: 'ls 7/29/2004 11:05'!
handlesFileEnding: ending
	^#('pr') includes: ending! !

!UISar methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('sar') includes: ending! !

!UInstaller methodsFor: 'testing' stamp: 'ls 7/29/2004 10:59'!
handlesFileEnding: anEnding
	^false! !

!UIFileOut methodsFor: 'testing' stamp: 'ls 9/4/2004 14:02'!
handlesFilename: filename
	^#('.cs' '.st' '.st.gz' '.cs.gz') anySatisfy: [ :ending | filename endsWith: ending ]! !

!UInstaller methodsFor: 'testing' stamp: 'ls 7/29/2004 11:08'!
handlesFilename: filename
	^self handlesFileEnding: (FileDirectory extensionFor: filename)
	! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
hasPackageNamed: name
	^self packages anySatisfy: [ :p | p name = name ].
	! !

!UInstaller methodsFor: 'comparing' stamp: 'ls 7/29/2004 11:03'!
hash
	^self class hash! !

!UPackage methodsFor: 'comparing' stamp: 'ls 7/28/2004 09:58'!
hash
	^self name hash bitXor: self version hash! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/28/2004 10:02'!
hash
	^components inject: 1 into: [ :tally :new |
		(tally bitXor: new hash) hashMultiply ]! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 8/9/2004 14:21'!
homeMoviesUniverse 
	"[UUniverse switchSystemToUniverse: UUniverse homeMoviesUniverse]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: 8940;
		description: 'Home Movies';
		yourself! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/28/2004 10:19'!
includesPackageNamed: name
	^self installedPackages anySatisfy: [ :p | p name = name ]! !

!UAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 18:02'!
initialize
	username _ 'joeblow'.
	password _ ''.
	packageNames _ Set new.! !

!UConfiguration methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:55'!
initialize
	installedPackages _ Set new.! !

!UInstaller class methodsFor: 'initialization' stamp: 'ls 7/29/2004 11:09'!
initialize
	Installers ifNil: [ Installers _ Set new ].
	
	{UIFileOut. UIMonticello. UIMpeg. UIProject. UISar} do: [ :c |
		self registerInstaller: c new ]! !

!UPWild methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 21:35'!
initialize
	accounts _ OrderedCollection new! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 11:43'!
initialize
	name _ '(unnamed package)'.
	depends _ Set new.
	description _ ''.
	url _ 'file:///dev/null' asUrl.
	version _ UVersion readFromString: '0'.! !

!UServerStepperMorph methodsFor: 'initialization' stamp: 'ls 7/28/2004 13:41'!
initialize
	super initialize.
	timeOfLastFlash _ DateAndTime now.! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 1/16/2005 14:07'!
initialize
	super initialize.
	packages _ Set new.! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 1/16/2005 14:07'!
initialize
	description _ 'some universe'.! !

!UUniverseBrowser class methodsFor: 'class initialization' stamp: 'ls 9/4/2004 14:29'!
initialize
	TheWorldMenu registerOpenCommand: {'Universe Browser'. {self. #open}}.
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0).! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 7/30/2004 15:05'!
initialize
	configuration _ UConfiguration forSystem.
	selectedPackageIndex _ 0.
	packagesToInstall _ Set new.
	self universe: UUniverse systemUniverse.
! !

!UUniverseClient class methodsFor: 'class initialization' stamp: 'ls 8/5/2004 17:09'!
initialize
	Preferences addPreference: #universesUsesHTTP category: #publishing default: false balloonHelp: 'The Universes tools normally uses a TCP-based protocol, but some firewalls block it.  Enable this preference to have it use an HTTP-based protocol instead.'! !

!UUniverseEditor class methodsFor: 'class initialization' stamp: 'ls 7/29/2004 18:08'!
initialize
	TheWorldMenu registerOpenCommand: {'Universe Editor'. {self. #open}}! !

!UUniverseClient methodsFor: 'initialization' stamp: 'ls 8/5/2004 17:16'!
initialize: aUniverse
	universe _ aUniverse.
	
	inMessages _ OrderedCollection new.
	outMessages _ OrderedCollection new.
	
	lastConnectionStart _ DateAndTime epoch.! !

!UUniverseEditor methodsFor: 'initialization' stamp: 'ls 7/30/2004 15:35'!
initialize: universe0
	universe _ universe0.
	client _ UUniverseClient forUniverse: universe.
	username _ Utilities authorInitialsPerSe.
	password _ ''.
	
	packageEditors _ Set new.! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 8/2/2004 16:54'!
initializeForUniverse: aUniverse
	universe _ aUniverse.
	policy _ UPolicy new.
	connectionQueue _ nil.
	connections _ Set new.
	oneShotRequests _ SharedQueue new.! !

!UOneShotConnection methodsFor: 'initialize-release' stamp: 'ls 8/2/2004 16:33'!
initializeWithInMessage: inMessage0  andOutQueue: aSharedQueue
	inputMessage _ inMessage0.
	outputQueue _ aSharedQueue.
	hasBeenRead _ false.
	hasBeenWritten _ false.! !

!UPackage methodsFor: 'installing' stamp: 'ls 9/4/2004 14:55'!
install
	| filename doc file downloadDir |
	downloadDir _ FileDirectory default directoryNamed: 'universetmp'.
	downloadDir assureExistence.
	
	filename _ self url path last.
	(downloadDir isAFileNamed: filename)
	ifFalse: [
		"download the file"
		doc _ url retrieveContents.
		((doc contentType asString = 'text/plain') and: [
			doc content beginsWith: 'error']) ifTrue: [
			"HACK to see if the download failed; the real solution is to make retrieveContents report errors"
			^self error: 'download failed' ].
		file _ downloadDir newFileNamed: filename.
		file binary.
		file nextPutAll: doc content.
		file close. ].
	
	UInstaller installFileNamed: (downloadDir fullNameFor: filename).
	
		! !

!UIFileOut methodsFor: 'installing' stamp: 'ls 7/29/2004 20:01'!
install: inStream  usingBaseName: basename
	"find a changeset name that is not used"
	| num changesetName stream |
	num _ 0.
	[  	changesetName _ basename.
	   	num > 0 ifTrue:[ changesetName _ changesetName, '-', num printString. ].
		(ChangeSorter changeSetNamed: changesetName) notNil ]
	whileTrue: [ num _ num + 1 ].
	
	"decompress if necessary"
	inStream peek asInteger = 16r1F
		ifTrue: [ stream _ ReadStream on: ((GZipReadStream on: inStream) upToEnd) asString ]
		ifFalse: [ stream _ inStream ].
		
	ChangeSorter newChangesFromStream: stream named: changesetName! !

!UInstaller methodsFor: 'installing' stamp: 'ls 7/29/2004 11:06'!
install: stream  usingBaseName: baseName
	self subclassResponsibility! !

!UIMpeg methodsFor: 'installing' stamp: 'ls 7/29/2004 11:39'!
install: stream usingBasename: basename
	| movieDir movieFile |
	movieDir := FileDirectory default directoryNamed: 'movies'.
	movieDir assureExistence.
	
	movieDir removeFileNamed: basename.
	
	movieFile _ movieDir newFileNamed: basename, '.mpeg'.
	stream binary.  movieFile binary.
	movieFile nextPutAll: stream upToEnd.
	movieFile close.
	
	Smalltalk at: #MPEGMoviePlayerMorph ifPresent: [ :player |
		player playFile: (movieDir fullNameFor: basename, '.mpeg') ]! !

!UIMonticello methodsFor: 'installing' stamp: 'ls 7/29/2004 19:26'!
installFileNamed: filename
	Smalltalk at: #MCMczReader ifPresent: [ :reader |
		^reader loadVersionFile: filename ].
	MczInstaller installFileNamed: filename! !

!UIProject methodsFor: 'installing' stamp: 'ls 9/18/2004 18:18'!
installFileNamed: filename
	FileDirectory splitName: filename to: [ :path :base |
		[ 	
			ProjectViewMorph openFromDirectory: (FileDirectory on: path) andFileName: base
		] on: ProjectEntryNotification do:
		[ :ex |
			"don't enter it" ] ]! !

!UISar methodsFor: 'installing' stamp: 'ls 7/29/2004 11:44'!
installFileNamed: filename
	SARInstaller installSAR: filename! !

!UInstaller class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 11:10'!
installFileNamed: filename
	(self installerForFilename: filename) installFileNamed: filename! !

!UInstaller methodsFor: 'installing' stamp: 'ls 9/4/2004 15:02'!
installFileNamed: filename
	| stream baseName |
	stream _ (FileStream readOnlyFileNamed: filename).
	baseName _ (FileDirectory splitName: filename to: [:path :base|base]) copyUpTo: $. .

	self install: stream usingBaseName: baseName.
	stream close.
	! !

!UConfiguration methodsFor: 'installing' stamp: 'ls 7/27/2004 21:55'!
installPackage: aPackage
	| matchingPackages |
	matchingPackages _ installedPackages select: [ :p | p name = aPackage name ].
	installedPackages removeAll: matchingPackages.
	aPackage install.
	installedPackages add: aPackage.
	! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:11'!
installSelectedPackage
	self anyPackageSelected ifFalse: [ ^self ].
	self planToInstallPackage: self selectedPackage.
	
	! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/27/2004 22:02'!
installedPackages
	^installedPackages! !

!UInstaller class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 11:10'!
installerForFilename: filename
	^self registeredInstallers detect: [ :i | i handlesFilename: filename ] ifNone: [ self error: 'no installer handles file ', filename ].! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:34'!
isConnected
	^hasBeenWritten not! !

!UPWild class methodsFor: 'reasonable names' stamp: 'ls 7/29/2004 16:51'!
isReasonablePackageName: aString
	^aString allSatisfy: [ :c | c isAlphaNumeric or: [ ' -.' includes: c ]]! !

!UPWild class methodsFor: 'reasonable names' stamp: 'ls 7/28/2004 18:07'!
isReasonableUsername: aString
	^aString allSatisfy: [ :c | c isAlphaNumeric ]! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 7/29/2004 09:25'!
loadFromCheckpoint
	"reload from a checkpoint"
	| file savedObject |
	(saveDirectory isAFileNamed: 'checkpoint')
		ifTrue: [ file _ saveDirectory readOnlyFileNamed: 'checkpoint' ]
		ifFalse: [ file _ saveDirectory readOnlyFileNamed: 'checkpoint.die' ].

	savedObject := file fileInObjectAndCode.
	file close.
	
	universe := savedObject first.
	policy := savedObject second.	! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:37'!
makeButtonWithAction: selector andGetState: getStateSelector andLabel: aString
	^(PluggableButtonMorph on: self getState: getStateSelector action: selector)
		label: aString;
		useRoundedCorners;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		onColor: self defaultBackgroundColor offColor: self defaultBackgroundColor muchLighter;
		yourself! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:35'!
makeButtonWithAction: selector  andLabel: aString
	^self makeButtonWithAction: selector andGetState: #returnTrue andLabel: aString! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 15:56'!
makeButtonWithAction: selector  andLabel: aString
	^(PluggableButtonMorph on: self getState: nil action: selector)
		label: aString;
		useRoundedCorners;
		yourself! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:45'!
makeFieldGet: getSelector  set: setSelector
	| field fieldHeight |
	fieldHeight _ TextStyle default defaultFont pointSize + 8.
		
		
	field := PluggableTextMorph on: self text: getSelector accept: setSelector.
	field extent: 200@fieldHeight.
	field hideScrollBarsIndefinitely.
	field setProperty: #alwaysAccept toValue: true.
	
	fields ifNil: [ fields _ OrderedCollection new].
	fields add: field.
	
	^field! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:34'!
makeFieldGet: getSelector  set: setSelector
	| field fieldHeight |
	fieldHeight _ TextStyle default defaultFont pointSize + 8.
		
		
	field := PluggableTextMorph on: self text: getSelector accept: setSelector.
	field extent: 200@fieldHeight.
	field hideScrollBarsIndefinitely.
	field setProperty: #alwaysAccept toValue: true.
	
	fields ifNil: [ fields _ OrderedCollection new].
	fields add: field.
	
	^field! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:46'!
makePasswordFieldGet: getSelector  set: setSelector
	| field |
	field _ self makeFieldGet: getSelector set: setSelector.
	field font: (StrikeFont passwordFontSize: TextStyle default defaultFont pointSize).
	^field! !

!UPStable methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 22:08'!
masterPassword: password
	masterPassword _ password! !

!UPStable methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 22:08'!
masterUser: userName
	masterUser _ userName! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/30/2004 15:44'!
morphicView
	| win column nameRow submitButton passwordRow password1Row password2Row emailRow |
	window ifNotNil: [ ^window ].
	win _ SystemWindow labelled: 'Account Editor'.

	column _ AlignmentMorph newColumn.
	win addMorph: column frame: (0@0  extent:  1@1).
	

	nameRow _ AlignmentMorph newRow.
	nameRow addMorph: (StringMorph contents: 'name').
	nameRow addMorphBack: (self makeFieldGet: #username set: nil).
	column addMorphBack: nameRow.
	
	passwordRow _ AlignmentMorph newRow.
	passwordRow addMorph: (StringMorph contents: 'password').
	passwordRow addMorphBack: (self makePasswordFieldGet: #password set: nil).
	column addMorphBack: passwordRow.
	
	password1Row _ AlignmentMorph newRow.
	password1Row addMorph: (StringMorph contents: 'new password').
	password1Row addMorphBack: (self makePasswordFieldGet: #password1 set: #password1:).
	column addMorphBack: password1Row.

	password2Row _ AlignmentMorph newRow.
	password2Row addMorph: (StringMorph contents: 'confirm:').
	password2Row addMorphBack: (self makePasswordFieldGet: #password2 set: #password2:).
	column addMorphBack: password2Row.

	emailRow _ AlignmentMorph newRow.
	emailRow addMorph: (StringMorph contents: 'email').
	emailRow addMorphBack: (self makeFieldGet: #newEmail set: #newEmail:).
	column addMorphBack: emailRow.
	
	submitButton _ PluggableButtonMorph on: self getState: nil action: #submit.
	submitButton label: 'Submit'.
	submitButton useRoundedCorners.
	column addMorphBack: submitButton.
	
	^window _ win! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/29/2004 15:25'!
morphicView
	| win column nameRow versionRow urlRow descriptionField submitButton dependsRow |
	window ifNotNil: [ ^window ].
	win _ SystemWindow labelled: 'Package Editor'.

	column _ AlignmentMorph newColumn.
	win addMorph: column frame: (0@0  extent:  1@1).
	

	nameRow _ AlignmentMorph newRow.
	nameRow addMorph: (StringMorph contents: 'name').
	nameRow addMorphBack: (self makeFieldGet: #packageName set: #packageName:).
	column addMorphBack: nameRow.
	

	versionRow _ AlignmentMorph newRow.
	versionRow addMorph: (StringMorph contents: 'version').
	versionRow addMorphBack: (self makeFieldGet: #versionString set: #versionString:).
	column addMorphBack: versionRow.
	
	
	urlRow _ AlignmentMorph newRow.
	urlRow addMorph: (StringMorph contents: 'url').
	urlRow addMorphBack: (self makeFieldGet: #urlString set: #urlString:).
	column addMorphBack: urlRow.
	
	dependsRow _ AlignmentMorph newRow.
	dependsRow addMorph: (StringMorph contents: 'depends').
	dependsRow addMorphBack: (self makeFieldGet: #dependsString set: #dependsString:).
	column addMorphBack: dependsRow.

	column addMorphBack: (StringMorph contents: 'Description:').
	
	descriptionField _ self makeFieldGet: #description set: #description:.
	descriptionField height: 200.
	column addMorphBack: descriptionField.
	
	submitButton _ PluggableButtonMorph on: self getState: nil action: #submit.
	submitButton label: 'Submit'.
	submitButton useRoundedCorners.
	column addMorphBack: submitButton.
	
	^window _ win! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 15:09'!
morphicView
	| win packageList installButton doInstallButton titleArea buttonList upgradeButton updateListButton descriptionArea installButtonHolder |
	win _ SystemWindow labelled: 'Universe'.
	win model: self.
	
	titleArea _ PluggableTextMorph on: self text: #titleAreaText accept: nil.
	titleArea hideScrollBarsIndefinitely.
	titleArea name: 'universe title'.
	win addMorph: titleArea frame: (0@0 extent: 1@0.1).
	
	packageList _ PluggableListMorph on: self list: #packageDescriptions  selected: #selectedPackageIndex changeSelected: #selectedPackageIndex: menu: nil.
	packageList name: 'package list'.
	win addMorph: packageList frame: ((0@0.1) extent: (0.5@0.8)).
	
	installButtonHolder _ Morph new.  "necessary to keep SystemWindow from screwing up the colors of the button"
	installButtonHolder 
		name: 'holder for install button';
		layoutPolicy: TableLayout new;
		borderColor: self defaultBackgroundColor.
	doInstallButton _ self makeButtonWithAction: #doInstall andGetState: #anyPackagesToInstall andLabel: 'Install Selections'.
	doInstallButton
		useSquareCorners;
		borderWidth: 0;
		setBalloonText: 'Download and install all the packages that you have selected';
		name: 'install selections button'.
	installButtonHolder addMorph: doInstallButton.
	win addMorph: installButtonHolder frame: ((0@0.9) extent:(1@0.1)).

	descriptionArea _ PluggableTextMorph on: self text: #selectedPackageDescription accept: nil.
	win addMorph: descriptionArea frame: ((0.5@0.4) extent: (0.5@0.5)).
	
	buttonList _ AlignmentMorph newColumn.
	buttonList
		cellInset: 0@3;
		name: 'button list'.
	win addMorph: buttonList frame: ((0.5@0.1) extent: (0.5@0.3)).
		
	installButton _ self makeButtonWithAction: #installSelectedPackage andGetState: #canMarkSelectionForInstallation andLabel: 'install package'.
	installButton setBalloonText: 'Select this package for installation'.
	buttonList addMorph: installButton.
	
	upgradeButton _ self makeButtonWithAction: #chooseUpgrades andLabel: 'upgrade all'.
	upgradeButton setBalloonText: 'Select every possible upgrade for the currently installed packages'.
	buttonList addMorphBack: upgradeButton.
	
	updateListButton _ self makeButtonWithAction: #requestPackageList andLabel: 'update list'.
	updateListButton setBalloonText: 'Refresh the list of available packages from the network'.
	buttonList addMorphBack: updateListButton.
	
	^win! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:28'!
morphicView
	| win universeDescription buttonList usernameRow passwordRow button fieldHeight  |
	win _ SystemWindow labelled: 'Universe Editor'.
	win model: self.
	
	universeDescription := PluggableTextMorph on: self text: #universeDescription accept: nil.
	win addMorph: universeDescription frame: (0@0 extent: 1@0.1).
	
	buttonList _ AlignmentMorph newColumn.
	win addMorph: buttonList frame: (0@0.1 extent: 1@0.9).
	
	fieldHeight _ TextStyle default defaultFont pointSize + 8.
	
	usernameRow _ AlignmentMorph newRow.
	usernameRow addMorph: (StringMorph contents: 'username').
	usernameField _ (PluggableTextMorph on: self text: #username accept: #username:).
	usernameField extent: 200@fieldHeight.
	usernameField hideScrollBarsIndefinitely.
	usernameField setProperty: #alwaysAccept toValue: true.
	usernameRow addMorphBack: usernameField.
	buttonList addMorphBack: usernameRow.
	
	passwordRow _ AlignmentMorph newRow.
	passwordRow addMorph: (StringMorph contents: 'password').
	passwordField _ PluggableTextMorph on: self text: #password accept: #password:.
	passwordField font: (StrikeFont passwordFontSize: TextStyle default defaultFont pointSize).
	passwordField extent: 200@fieldHeight.
	passwordField hideScrollBarsIndefinitely.
	passwordField setProperty: #alwaysAccept toValue: true.
	passwordRow addMorphBack: passwordField.
	buttonList addMorphBack: passwordRow.
	
	button _ self makeButtonWithAction: #createAccount andLabel: 'createAccount'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #editAccount andLabel: 'edit account'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #newPackage andLabel: 'new package'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #newPackageVersion andLabel: 'new package version'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #removeVersion andLabel: 'remove package version'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #requestPackageList andLabel: 'update package list'.
	buttonList addMorphBack: button.
	
	^win! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
name
	^name! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
name: aString
	name _ aString! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:47'!
new
	self shouldNotImplement ! !

!UUniverseClient class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 15:06'!
new
	^self forUniverse: UUniverse systemUniverse! !

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:13'!
new
	| choice choices |
	choices := UUniverse systemUniverse standardUniverses asArray.
	choices isEmpty ifTrue: [ ^self error: 'no standard universes installed' ].
	choices size = 1 ifTrue: [
		choice _ choices anyOne ]
	ifFalse: [
		| menu |
		menu _
			SelectionMenu
				labels: (choices collect: [ :u | u description ])
				selections: choices.
		choice _ menu startUpWithCaption: 'edit which universe?'.
		choice ifNil: [ ^self ] ].
	
	^self forUniverse: choice! !

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 10:31'!
new
	^self shouldNotImplement ! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:52'!
newEmail
	^newEmail! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:53'!
newEmail: anObject
	newEmail _ anObject! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 8/4/2004 15:46'!
newInMessage: aMessage
	aMessage applyToClient: self.
	inMessages add: aMessage.
	! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 22:00'!
newPackage
	| editor |
	self acceptFields.

	editor _ UPackageEditor package: UPackage new whenComplete: [ :p |
		self acceptFields.
		self sendMessage: (UMAddPackage username: username password: password package: p) ].
	editor openInMorphic.
	packageEditors add: editor.
! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 1/16/2005 14:05'!
newPackageList: newPackages
	packagesToInstall _ Set new.  "the selected packages may not be there any more!!"
	self selectedPackageIndex: 0.
	
	self changed: #packageDescriptions.
	! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 14:59'!
newPackageList: newPackages
	universe packages: newPackages.
	! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 21:59'!
newPackageVersion
	| package editor name |
	self acceptFields.

	universe packageNames isEmpty ifTrue: [
		^self inform: 'no packages in this universe' ].
	name _ (SelectionMenu selections: universe packageNames asSortedArray) startUpWithCaption: 'Package to update?'.
	name ifNil: [ ^self ].
	package _ universe newestPackageNamed: name asSymbol.
	
	editor _ UPackageEditor package: package deepCopy whenComplete: [ :p |
		self acceptFields.
		self sendMessage: (UMAddPackage username: username password: password package: p) ].
	editor openInMorphic.
	packageEditors add: editor.
! !

!UUniverse methodsFor: 'packages' stamp: 'ls 7/28/2004 17:17'!
newestPackageNamed: name
	| potentials sorted |
	potentials _ self packagesNamed: name.
	sorted _ potentials asSortedCollection: [ :p1 :p2 | p1 version < p2 version ].
	^sorted last! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:32'!
nextOrNil
	hasBeenRead ifTrue:[ ^nil ].
	hasBeenRead _ true.
	^inputMessage! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:53'!
nextPut: anObject
	outputQueue nextPut: anObject.
	hasBeenWritten _ true! !

!UUniverseBrowser class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:15'!
open
	^self new open! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:19'!
open
	self morphicView openInWorld! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:27'!
open
	self morphicView openInWorld.
	"self requestPackageList."! !

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:13'!
open
	^self new open! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:50'!
openInMorphic
	^self morphicView openInWorld! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:35'!
openInMorphic
	^self morphicView openInWorld! !

!UUniverseServer methodsFor: 'stepping' stamp: 'ls 8/2/2004 17:15'!
openStepperMorph
	(UServerStepperMorph new server: self; yourself) openInWorld! !

!UUniverseBrowser class methodsFor: 'dependencies' stamp: 'ls 7/29/2004 15:16'!
orderPackagesByDependency: packages
	"return a collection of the specified packages such that, when possible, any dependencies of a package are ordered before that package"
	"The present algorithm is simple but slow..."
	| remainingPackages orderedPackages packagesToAdd |
	remainingPackages _ Set new.
	orderedPackages _ OrderedCollection new.
	remainingPackages addAll: packages.
	
	"each time through this loop, add to orderedPackages any packages whose dependencies are not in remainaingPackages"
	[	packagesToAdd := remainingPackages select: [ :p | p depends noneSatisfy: [ :depName | remainingPackages anySatisfy: [ :p2 | p2 name = depName ] ] ].
		packagesToAdd isEmpty not
	] whileTrue: [
		orderedPackages addAll: packagesToAdd.
		remainingPackages := remainingPackages difference: packagesToAdd ].
	
	orderedPackages addAll: remainingPackages.
	^orderedPackages
! !

!UAccount methodsFor: 'packages' stamp: 'ls 7/28/2004 18:03'!
ownsPackageName: name
	^packageNames includes: name! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:45'!
package
	^package! !

!UMPackageAdded class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:07'!
package: aPackage
	^self basicNew
		package: aPackage;
		yourself! !

!UMPackageAdded methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:59'!
package: aPackage
	package _ aPackage! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 18:00'!
package: package mayBeAddedBy: user withPassword: password
	^(user = masterUser and: [ password = masterPassword ])
		ifTrue: [ UPolicyResponse allowed ]
		ifFalse: [ UPolicyResponse denied ]! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 21:34'!
package: aPackage  mayBeAddedBy: username  withPassword: password
	^self tryToGivePackageName: aPackage name toUsername: username withPassword: password! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
package: aPackage  mayBeAddedBy: user  withPassword: password
	^UPolicyResponse allowed! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
package: aPackage  mayBeAddedBy: user  withPassword: password
	^UPolicyResponse denied! !

!UPackageEditor class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 16:28'!
package: aPackage  whenComplete: aBlock
	^self basicNew
		package: aPackage  whenComplete: aBlock;
		yourself! !

!UPackageEditor methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 16:28'!
package: aPackage  whenComplete: aBlock
	package _ aPackage.
	whenComplete _ aBlock.
	! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 15:00'!
packageAdded: newPackage
	universe addPackage: newPackage! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 22:02'!
packageDescriptions
	| commentary |
	^self sortedPackages collect: [ :p |
		commentary _ ''.
		(packagesToInstall includes: p) ifTrue: [ commentary _ ' (install)' ].
		(configuration installedPackages includes: p) ifTrue: [ commentary _ ' (installed)' ].
		
		p printString, commentary. ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:38'!
packageName
	^package name! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:43'!
packageName: aString
	package name: aString asString.
	self changed: #packageName.
	^true! !

!UMPackageRemoved methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:57'!
packageName: aString  version: aVersion
	packageName _ aString.
	version _ aVersion.! !

!UMPackageRemoved class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:58'!
packageName: aString version: aVersion
	^self basicNew
		packageName: aString version: aVersion;
		yourself! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/28/2004 10:18'!
packageNamed: name
	^self installedPackages detect: [ :p | p name = name ]! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 18:00'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	(user = masterUser and: [ password = masterPassword ])
		ifTrue: [ ^UPolicyResponse allowed ]
		ifFalse: [ ^UPolicyResponse denied ]! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 18:15'!
packageNamed: packageName withVersion: version mayBeRemovedBy: username withPassword: password
	^self tryToGivePackageName: packageName toUsername: username withPassword: password! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	^UPolicyResponse allowed! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	^UPolicyResponse denied! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
packageNames
	| names |
	names _ Set new.
	self packages do: [ :p | names add: p name ].
	^names! !

!UCompoundUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:09'!
packages
	^Array streamContents: [ :pstr |
		components do: [ :univ |
			pstr nextPutAll: univ packages ] ]! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 1/16/2005 14:07'!
packages
	^packages! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:08'!
packages
	^self subclassResponsibility! !

!UMPackageList class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 12:01'!
packages: aCollection
	^self basicNew
		packages: aCollection;
		yourself! !

!UMPackageList methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 12:01'!
packages: aCollection
	packages _ aCollection! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 1/16/2005 14:07'!
packages: aCollection
	packages _ Set new.
	packages addAll: aCollection! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:07'!
packagesNamed: name
	^self packages select: [ :p | p name = name ].
	! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:50'!
password
	^password! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:50'!
password
	^password! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 15:54'!
password
	^password! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password1
	^newPassword! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password1: aString
	newPassword _ aString asString.
	self changed: #password1.
	^true! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password2
	^newPassword2! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password2: aString
	newPassword2 _ aString asString.
	self changed: #password2.
	^true! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
password: anObject
	password _ anObject! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 16:18'!
password: aString
	password _ aString asString.
	^true! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:11'!
planToInstallPackage: package
	"plan to install a package plus its dependencies; refuses if any dependencies cannot be met"

	self planToInstallPackageWithoutUIUpdate: package.
	self changed: #packageDescriptions.
	! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:31'!
planToInstallPackageWithoutUIUpdate: initialPackage
	"same as planToInstallPackage:, but does not called #changed:.  Don't call this unless you later call #changed: yourself"
	| newPackages |
	"find all packages needed to install this one"
	newPackages _ self allPackagesNeededToInstall: initialPackage orIfImpossible: [ :missingDep |
		^self notify: 'could not find necessary package: ', missingDep ].
	
	packagesToInstall removeAllSuchThat: [ :p | p name = initialPackage name ].
	newPackages do: [ :p | packagesToInstall add: p ].
	! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:32'!
policy: aPolicy
	policy _ aPolicy! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 7/29/2004 16:07'!
possiblySaveCheckpoint
	(lastSaveTime isNil or: [ (DateAndTime now - lastSaveTime) > (Duration minutes: 30) ]) ifTrue: [
		self saveCheckpoint.
		lastSaveTime _ DateAndTime now ].! !

!UPackage methodsFor: 'printing' stamp: 'ls 7/27/2004 21:19'!
printOn: aStream
	aStream
		nextPutAll: name;
		nextPutAll: ' version ';
		print: version! !

!UVersion methodsFor: 'printing' stamp: 'ls 7/27/2004 17:28'!
printOn: aStream
	components do: [ :comp | aStream nextPutAll: comp asString ].! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 21:28'!
processConnection: aConnection
	| message |
	aConnection isConnected ifFalse: [ ^self destroyConnection: aConnection ].
	
	aConnection processIO.
	[ 	message _ aConnection nextOrNil.
	  	message notNil
	] whileTrue: [
	  	self processRawMessage: message fromConnection: aConnection ].

	aConnection isConnected
		ifTrue: [ aConnection processIO.  "start sending out the response" ]
		ifFalse: [ self destroyConnection: aConnection ]! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:43'!
processConnections
	connections copy do: [ :c |
		self processConnection: c ]! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:32'!
processIO! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 8/4/2004 15:55'!
processIO
	| rawMsg |
	(stringSocket notNil and: [ stringSocket isConnected not ]) ifTrue: [
		"connection has died"
		stringSocket destroy.
		stringSocket _ nil ].

	
	(outMessages isEmpty not and: [ socket isNil and: [ stringSocket isNil ] ]) ifTrue: [
		"there are outgoing messages queued but there is no stringSocket"
		(DateAndTime now - lastConnectionStart) > (Duration minutes: 1) ifTrue: [
			self startConnecting ] ].
	
	socket ifNotNil: [
		"a connection is in progress"
		
		socket isConnected ifTrue: [
			"connection completed"
			stringSocket _ StringSocket on: socket.
			socket _ nil. ]
		ifFalse: [
			socket isWaitingForConnection ifFalse: [
				"the connection failed"
				inMessages add: (UMConnectionFailed description: 'connection failed').
				^self disconnect ] ] ].

	
	stringSocket ifNil: [ ^self ].
		
	[ outMessages isEmpty ] whileFalse: [
		stringSocket nextPut: outMessages removeFirst asStringArray ].
	
	stringSocket processIO.
	
	[	rawMsg _ stringSocket nextOrNil.
		rawMsg isNil not
	] whileTrue: [ 
		self newInMessage: (UMessage fromStringArray: rawMsg) ]! !

!UUniverseBrowser methodsFor: 'server communication' stamp: 'ls 7/30/2004 15:08'!
processNetworking
	clients do: [ :client |
		client receivedMessagesDo: [ :message |
			message applyToInstaller: self ] ].
	! !

!UUniverseEditor methodsFor: 'networking' stamp: 'ls 7/30/2004 15:35'!
processNetworking
	client receivedMessagesDo: [ :message |
		message applyToEditor: self ].
! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/2/2004 16:55'!
processNetworking
	self checkForNewConnections.
	self checkForOneShotRequests.
	self processConnections.
	! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 13:12'!
processRawMessage: aStringArray  fromConnection: connection
	| message |
	message _ UMessage fromStringArray: aStringArray.
	message applyToServer: self forConnection: connection.
! !

!UVersion class methodsFor: 'instance creation' stamp: 'ls 7/27/2004 17:27'!
readFrom: stream
	| components |
	components _ OrderedCollection new.
	[ stream atEnd ] whileFalse: [
		stream peek isDigit ifTrue: [
			components add: (Integer readFrom: stream) ]
		ifFalse: [
			components add: (String streamContents: [ :compStr |
				[ stream atEnd not and: [ stream peek isDigit not ] ] whileTrue: [
					compStr nextPut: stream next ] ]) ] ].
		
	^self fromComponents: components! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:58'!
reason
	^reason! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
reason: anObject
	reason _ anObject! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:33'!
receivedMessagesDo: aBlock
	"check for new messages, and then evaluate aBlock for each message that is currently available"
	self processIO.
	[ inMessages isEmpty ] whileFalse: [
		aBlock value: inMessages removeFirst ]! !

!UInstaller class methodsFor: 'registry' stamp: 'ls 7/29/2004 11:02'!
registerInstaller: installer
	Installers add: installer! !

!UInstaller class methodsFor: 'registry' stamp: 'ls 7/29/2004 11:11'!
registeredInstallers
	^Installers asArray! !

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:07'!
removePackage: aPackage
	packages remove: aPackage! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
removePackageNamed: packageName withVersion: version
	| packagesToRemove |
	packagesToRemove _ self packages select: [ :p | p name = packageName and: [ p version = version ] ].
	packagesToRemove do: [ :p | self removePackage: p ].
	! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/29/2004 15:46'!
removeVersion
	| name packages versionString versions version |
	self acceptFields.

	universe packageNames isEmpty ifTrue: [
		^self inform: 'no packages in this universe' ].

	name _ (SelectionMenu selections: universe packageNames asSortedArray) startUpWithCaption: 'Remove a version of which package?'.
	name ifNil: [ ^self ].
	
	packages _ universe packagesNamed: name asSymbol.
	versions _ (packages collect: [ :p | p version ]) asSortedCollection.
	
	versionString _ (SelectionMenu selections: (versions collect: [ :v | 'version ', v printString ])) startUpWithCaption: 'Version of ', name, ' to remove?'.
	versionString ifNil: [ ^self ].
	version := UVersion readFromString: (versionString allButFirst: 'version ' size).
	
	self sendMessage: (UMRemovePackage username: username password: password packageName: name packageVersion: version).
! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 15:02'!
removedPackageNamed: packageName  withVersion: version
	universe removePackageNamed: packageName  withVersion: version! !

!UUniverseBrowser methodsFor: 'server communication' stamp: 'ls 1/16/2005 14:05'!
requestPackageList
	clients do: [ :client |
		client sendMessage: (UMRequestPackages new)  ].
	self processNetworking.! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:23'!
requestPackageList
	self sendMessage: (UMRequestPackages new).
	! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:35'!
returnTrue
	"return true; used for buttons that are always enabled"
	^true! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 7/29/2004 09:25'!
saveCheckpoint
	"save a checkpoint"
	| tmpFile |
	saveDirectory deleteFileNamed: 'checkpoint.tmp'.
	
	tmpFile := saveDirectory newFileNamed: 'checkpoint.tmp'.
	(SmartRefStream on: tmpFile) nextPut: {universe.policy}; close.
	
	saveDirectory deleteFileNamed: 'checkpoint.die'.
	saveDirectory rename: 'checkpoint.tmp' toBe: 'checkpoint'.	
	saveDirectory deleteFileNamed: 'checkpoint.die'.
	! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 09:16'!
saveDirectory: aDirectory
	saveDirectory _ aDirectory! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:33'!
selectedPackage
	^self sortedPackages at: self selectedPackageIndex! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/29/2004 16:13'!
selectedPackageDescription
	self anyPackageSelected ifFalse: [ ^ '' ].
	^String streamContents: [ :str |
		str nextPutAll: self selectedPackage description; cr; cr.
		self selectedPackage depends isEmpty ifFalse: [
			str nextPutAll: 'Depends on:'; cr.
			self selectedPackage depends do: [ :depName |
				str tab; nextPutAll: depName; cr ].
			str cr].
		str print: self selectedPackage url; cr.].
	
			! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:26'!
selectedPackageIndex
	^selectedPackageIndex! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 9/4/2004 14:35'!
selectedPackageIndex: anInteger
	selectedPackageIndex _ anInteger.
	self changed: #selectedPackageIndex.
	self changed: #selectedPackageDescription.
	self changed: #canMarkSelectionForInstallation.! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 14:49'!
sendError: description onConnection: stringSocket
	self sendMessage: (UMError description: description) onConnection: stringSocket! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 8/5/2004 17:16'!
sendMessage: aMessage
	"send the specified message to the server"
	self useHTTP ifTrue: [
		"send the one message over HTTP, and retrieve one or zero messages in return"
		| serverURL requestArgs responseDoc responseMessage |
		serverURL _ HttpUrl schemeName: 'http' authority: (universe serverName, ':', (universe serverPort + 1) printString) path: #('') query: nil.
		requestArgs _ Dictionary new.
		requestArgs at: 'message' put: {StringSocket encodeStringArray: aMessage asStringArray}.
		responseDoc _ serverURL postFormArgs: requestArgs.

		responseMessage _ [
			UMessage fromStringArray: (StringSocket decodeStringArray: (responseDoc content))
		] ifError: [ :ignored1 :ignored2 | UMError description: 'error from server: ', responseDoc content ].
		self newInMessage: responseMessage. ]
	ifFalse: [
		"queue the message; processIO will move it forward"
		outMessages add: aMessage ]
	! !

!UUniverseEditor methodsFor: 'networking' stamp: 'ls 7/30/2004 15:40'!
sendMessage: aMessage
	client sendMessage: aMessage.
	! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 11:48'!
sendMessage: aMessage  onConnection: connection
	connection nextPut: aMessage asStringArray  ! !

!UServerStepperMorph methodsFor: 'initialization' stamp: 'ls 7/28/2004 13:19'!
server: aServer
	server _ aServer! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:21'!
serverName
	^serverName! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 10:37'!
serverName: aString	
	serverName _ aString! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:21'!
serverPort
	^serverPort! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 10:37'!
serverPort: port
	serverPort _ port! !

!UBrowserTestCase methodsFor: 'Running' stamp: 'ls 1/16/2005 14:11'!
setUp
	| package |
	universe _ UStandardUniverse new.
	
	package _ UPackage new.
	package name: 'A'.
	package addDependency: 'B'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'B'.
	package addDependency: 'C'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'C'.
	package addDependency: 'D'.
	package addDependency: 'E'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'D'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'E'.
	universe addPackage: package.

	package _ UPackage new.
	package name: 'Broken'.
	package addDependency: 'NonExistent'.
	universe addPackage: package.
	
! !

!UVersionTestCase methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:12'!
setUp
	typicalVersions := #(
		'1'
		'2'
		'1.5.7'
		'1.5.8'
		'1.6.2'
		'1.5'
		'1.5a'
		'1.5b'
		'1.6'
		'alpha'
		'beta'
	) collect: [ :str | UVersion readFromString: str ].
	! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:31'!
sortedPackages
	^universe packages asSortedCollection: [ :p1 :p2 |
		p1 name < p2 name or: [
			p1 name = p2 name and: [ p1 version < p2 version ] ] ].
	! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/2/2004 16:18'!
spaceToEncode: stringArray
	^stringArray inject: 4 into: [ :sum :array |
		sum + (array size + 4) ].! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 9/4/2004 14:08'!
squeak37Universe 
	"[UUniverse switchSystemToUniverse: UUniverse squeak37Universe]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: 7273;
		description: 'Squeak 3.7';
		yourself! !

!UCompoundUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:50'!
standardUniverses
	^Array streamContents: [ :str |
		components do: [ :comp |
			str nextPutAll: comp standardUniverses  ] ]! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:09'!
standardUniverses
	^{self}! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:09'!
standardUniverses
	"return a list of standard universes within the receiver.  See StandardUniverse"
	^#()! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 7/30/2004 15:31'!
startConnecting
	"start a new connection to the server"
	self disconnect.
	
	lastConnectionStart _ DateAndTime now.
	
	socket _ Socket newTCP.
	socket connectTo: (NetNameResolver addressForName: universe serverName) port: universe serverPort.
! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 13:21'!
startListening
	self stopListening.
	connectionQueue _ ConnectionQueue portNumber: universe serverPort queueLength: 5.
	! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/3/2004 18:10'!
startListeningOnHttp
	self stopListeningOnHttp.
	
	(HttpService startOn: (universe serverPort + 1) named: self comancheServiceName) plug: [ :req |
		| requestArray responseQueue responseArray |
		requestArray _ (StringSocket decodeStringArray: (req fields at: 'message') anyOne).
		responseQueue _ SharedQueue new.
		self eventuallyRespondTo: requestArray on: responseQueue.
		responseArray _ responseQueue next.
		HttpResponse fromString: (StringSocket encodeStringArray: responseArray) contentType: 'application/octet-stream' ].! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:42'!
step
	server ifNotNil: [ server step ].
	
	(DateAndTime now - timeOfLastFlash ) > (Duration milliSeconds: 3000) ifTrue: [
		super step.
		timeOfLastFlash _ DateAndTime now. ].! !

!UUniverseBrowser methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:51'!
step
	self processNetworking! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
step
	self processNetworking! !

!UUniverseServer methodsFor: 'stepping' stamp: 'ls 7/29/2004 09:35'!
step
	"do any necessary periodic work, including polling the network connections"
	self processNetworking.
	self possiblySaveCheckpoint.! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:19'!
stepTime
	^10! !

!UUniverseBrowser methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:51'!
stepTime
	^10! !

!UUniverseBrowser methodsFor: 'stepping' stamp: 'ls 7/28/2004 14:02'!
stepTimeIn: window
	^self stepTime! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
stepTimeIn: window
	^10! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:41'!
stopListening	
	connectionQueue ifNotNil: [
		connectionQueue destroy.
		connectionQueue _ nil ].
	! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/3/2004 17:21'!
stopListeningOnHttp
	(HttpService servicesNamed: self comancheServiceName) do: [ :s | s stop; unregister ].
	! !

!UMMalformed methodsFor: 'accessing' stamp: 'ls 7/28/2004 11:45'!
stringArray: anObject
	stringArray _ anObject! !

!UPackage methodsFor: '*universes-messages' stamp: 'ls 7/28/2004 15:04'!
stringArrayEncoding
	^Array streamContents: [ :str |
		str
			nextPut: self name;
			nextPut: self version printString;
			nextPut: self description;
			nextPut: self url toText;
			nextPut: self depends size printString;
			nextPutAll: self depends.  ].! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:55'!
submit
	self acceptFields.
	newPassword = newPassword2 ifFalse: [
		^self inform: 'passwords do not match!!' ].
	whenDone value: newPassword value: newEmail
	! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:43'!
submit
	self acceptFields.
	whenComplete value: package! !

!UUniverse class methodsFor: 'system' stamp: 'ls 7/29/2004 18:54'!
switchSystemToUniverse: aUniverse
	SystemUniverse _ aUniverse! !

!UUniverse class methodsFor: 'system' stamp: 'ls 7/29/2004 20:03'!
systemUniverse
	"return the universe this image uses"
	^SystemUniverse ifNil: [ SystemUniverse _ self wildnWoollyUniverse ]! !

!UBrowserTestCase methodsFor: 'Running' stamp: 'ls 7/29/2004 17:40'!
testBasicDependency
	| browser neededPackages |
	browser _ UUniverseBrowser new universe: universe; yourself.
	neededPackages _ browser allPackagesNeededToInstall: (universe newestPackageNamed: 'A')  orIfImpossible: [ :ign | self error: 'dependency not found' ].
	
	self should: [ neededPackages size = 5 ].
	
	browser _ UUniverseBrowser new universe: universe; yourself.
	neededPackages _ browser allPackagesNeededToInstall: (universe newestPackageNamed: 'B')  orIfImpossible: [ :ign | self error: 'dependency not found' ].
	
	self should: [ neededPackages size = 4 ].! !

!UBrowserTestCase methodsFor: 'Running' stamp: 'ls 7/29/2004 17:39'!
testBrokenDependency
	| browser neededPackages |
	browser _ UUniverseBrowser new universe: universe; yourself.
	neededPackages _ browser allPackagesNeededToInstall: (universe newestPackageNamed: 'Broken')  orIfImpossible: [ :ign | nil ].
	self should: [ neededPackages isNil ].

	! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:19'!
testCompare
	self should: [ (UVersion readFromString: '1') < (UVersion readFromString: '2') ].
	self should: [ (UVersion readFromString: '1.5.7') < (UVersion readFromString: '1.5.8') ].
	self should: [ (UVersion readFromString: '1.5.7') < (UVersion readFromString: '1.6.2') ].
	self should: [ (UVersion readFromString: '1.5') < (UVersion readFromString: '1.5a') ].
	self should: [ (UVersion readFromString: '1.5a') < (UVersion readFromString: '1.5b') ].
	self should: [ (UVersion readFromString: '1.5b') < (UVersion readFromString: '1.6') ].! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:24'!
testFullOrder
	"check that all versions are in some order"

	typicalVersions do: [ :v1 |
		typicalVersions do: [ :v2 |
			self should: [
				(v1 < v2)
				or: [ (v2 < v1) 
				or: [ v1 = v2 ] ] ] ] ]



	! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/28/2004 09:59'!
testHash
	typicalVersions do: [ :v |
		self should: [ v hash = v copy hash ] ].
	
	self should: [ (UVersion readFromString: '1.5a') hash = (UVersion readFromString: '1.5a') hash ].! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:23'!
testReversedComparisons
	"check that it is never the case that v1<v2 and v2<v1"

	typicalVersions do: [ :v1 |
		typicalVersions do: [ :v2 |
			self should: [ (v1 < v2) not  or:  [  (v2 < v1) not ] ] ] ].

	! !

!UUniverseBrowser methodsFor: 'title pane' stamp: 'ls 7/29/2004 16:18'!
titleAreaText
	^universe description! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/29/2004 16:51'!
tryToGivePackageName: packageName toUsername: username  withPassword: password
	| account |
	(self class isReasonablePackageName: packageName) ifFalse: [
		^UPolicyResponse denied: 'invalid package name' ].
	
	account _ self findAccount: username withPassword: password.
	account ifNil: [ ^UPolicyResponse denied: 'incorrect password or no such user' ].
	
	(account ownsPackageName: packageName) ifTrue: [
		^UPolicyResponse allowed ].
	
	(accounts anySatisfy: [ :acc | acc ownsPackageName: packageName ]) ifTrue: [
		^UPolicyResponse denied: 'package is owned by another' ].
	
	account addPackageName: packageName.
	^UPolicyResponse allowed! !

!UUniverseServer methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:08'!
universe
	^universe! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 1/16/2005 14:11'!
universe: aUniverse
	universe _ aUniverse.
	
	clients ifNotNil: [ clients do: [ :client | client disconnect ] ].
	clients _ Dictionary new.
	universe standardUniverses do: [ :univ |
		clients at: univ put: (UUniverseClient forUniverse: univ) ].
	! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/29/2004 16:21'!
universeDescription 
	^universe description! !

!UUniverseBrowser class methodsFor: 'class initialization' stamp: 'ls 7/29/2004 18:15'!
unload
	TheWorldMenu unregisterOpenCommand: 'Universe Browser'! !

!UUniverseEditor class methodsFor: 'class initialization' stamp: 'ls 7/29/2004 18:14'!
unload
	TheWorldMenu unregisterOpenCommand: 'Universe Editor'! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
url
	^url! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:18'!
url: aURL
	url _ aURL! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:40'!
urlString
	^package url toText! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:43'!
urlString: aString
	package url: (Url absoluteFromText: aString asString).
	self changed: #urlString.
	^true! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 8/5/2004 17:16'!
useHTTP
	^useHTTP ifNil: [ Preferences valueOfFlag: #universesUsesHTTP ]! !

!UUniverseClient methodsFor: 'initialization' stamp: 'ls 8/3/2004 17:33'!
useHTTP: aBoolean
	useHTTP _ aBoolean! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:50'!
username
	^username! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:50'!
username
	^username! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 15:53'!
username
	^username! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
username: anObject
	username _ anObject! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 16:13'!
username: aString
	username _ aString asString.
	^true! !

!UMEditedAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:37'!
username: username  newPassword: newPassword  newEmail: newEmail
	^self basicNew
		username: username  newPassword: newPassword  newEmail: newEmail;
		yourself! !

!UMEditedAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 17:36'!
username: username0  newPassword: newPassword0  newEmail: newEmail0
	username _ username0.
	newPassword _ newPassword0.
	newEmail _ newEmail0.
	! !

!UMAddAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:34'!
username: username  password: password  email: email
	^self basicNew username: username  password: password  email: email! !

!UMAddAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:33'!
username: username0  password: password0  email: email0
	username _ username0.
	password _ password0.
	email _ email0.
	! !

!UAccountEditor class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:41'!
username: username0  password: password0  email: email0  whenDone: aBlock
	^self basicNew
		username: username0  password: password0  email: email0  whenDone: aBlock;
		yourself! !

!UAccountEditor methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 17:40'!
username: username0  password: password0  email: email0  whenDone: aBlock
	username _ username0.
	password _ password0.
	newPassword _ ''.
	newPassword2 _ ''.
	newEmail _ email0.
	whenDone _ aBlock.

! !

!UMEditAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:36'!
username: username  password: password  newPassword: newPassword newEmail: newEmail
	^self basicNew username: username  password: password  newPassword: newPassword newEmail: newEmail! !

!UMEditAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:36'!
username: username0  password: password0  newPassword: newPassword0 newEmail: newEmail0
	username _ username0.
	password _ password0.
	newPassword _ newPassword0.
	newEmail _ newEmail0.
	! !

!UMAddPackage methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:37'!
username: username0 password: password0 package: package0
	username _ username0.
	password _ password0.
	package _ package0.
	! !

!UMAddPackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:37'!
username: username password: password package: package
	^self basicNew username: username password: password package: package! !

!UMRemovePackage methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:39'!
username: username0 password: password0 packageName: packageName0 packageVersion: packageVersion0
	username _ username0.
	password _ password0.
	packageName _ packageName0.
	packageVersion _ packageVersion0.
	! !

!UMRemovePackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:41'!
username: username password: password packageName: packageName packageVersion: packageVersion
	^self basicNew username: username password: password packageName: packageName packageVersion: packageVersion! !

!Integer methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:33'!
uversionEqual: anObject
	^anObject isInteger and: [ self = anObject ]! !

!String methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:32'!
uversionEqual: anObject
	^anObject isString and: [ self = anObject ]! !

!Integer methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:33'!
uversionLessThan: anObject
	^anObject isInteger and: [ self < anObject ]! !

!String methodsFor: '*universes-model' stamp: 'ls 7/27/2004 21:13'!
uversionLessThan: anObject
	^anObject isInteger or: [ self < anObject ]! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/27/2004 21:32'!
version
	^version! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
version: aVersion
	version _ aVersion.
	! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:39'!
versionString
	^package version printString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:39'!
versionString: aString
	package version: (UVersion readFromString: aString).
	self changed: #versionString.
	^true! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:30'!
waitForMessage
	"block until at least one message is available"
	self notYetImplemented.   "proper implementation requires changes to ObjectSocket"
	
	[ inMessages isEmpty ] whileTrue: [
		(socket isNil and: [  stringSocket isNil and: [ outMessages isEmpty ] ]) ifTrue: [
			self error: 'no more messages will every be available' ].
		
		socket ifNotNil: [ socket waitForConnectionFor: 60 ].
		stringSocket ifNotNil: [ stringSocket wait ].
		self processIO ].
! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:19'!
wantsSteps
	^true! !

!UUniverseBrowser methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:51'!
wantsSteps
	^true! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
wantsSteps
	^true! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 8/9/2004 14:21'!
wildnWoollyUniverse 
	"[UUniverse switchSystemToUniverse: UUniverse wildnWoollyUniverse]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: 4129;
		description: 'Wild and Woolly';
		yourself! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 18:01'!
window
	^window! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 17:12'!
window
	^window! !

!UOneShotConnection class methodsFor: 'instance creation' stamp: 'ls 8/2/2004 16:31'!
withInMessage: inMessage0  andOutQueue: aSharedQueue
	^self basicNew
		initializeWithInMessage: inMessage0  andOutQueue: aSharedQueue;
		yourself! !
UInstaller initialize!
UUniverseBrowser initialize!
UUniverseClient initialize!
UUniverseEditor initialize!
